#pragma once

#include "BindableBase.h"
#include <collection.h>
#include "IPresenter.h"

using namespace Platform;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Platform::Collections;
using namespace Windows::Foundation::Collections;

using namespace WsaWrcCpp::DataBinding;
using namespace WsaWrcCpp::Interfaces;

namespace WsaWrcCpp {
	namespace ViewModel {

		[Bindable]
		public ref class NameValuePair sealed : BindableBase
		{
		public:
			NameValuePair(String^ name, String^ value)
			{
				Name = name;
				Value = value;
			}
			property String^ Name{
				String^ get() { return _name; }
				void set(String^ value) {
					_name = value; NotifyPropertyChanged("Name");
				}}

			property String^ Value{
				String^ get() { return _value; }
				void set(String^ value) {
					_value = value; NotifyPropertyChanged("Value");
				}
			}
		private:
			String^ _name;
			String^ _value;
		};

		[Bindable]
		[Windows::Foundation::Metadata::WebHostHidden]
		public ref class MainViewModel sealed
			: public BindableBase
		{


		public:
			// Trivial properties
			property IPresenter^ Presenter;
			property ICommand^ ButtonCommand;

			//  Properties
			property bool CheckBox1 {
				bool get(); void set(bool); }

			property bool CheckBox2 {
				bool get(); void set(bool); }

			property String^ StatusResults {
				String^ get(); void set(String^); };

			property IVector<NameValuePair^>^ NameValueList {
				IVector<NameValuePair^>^ get(); void set(IVector<NameValuePair^>^); };

			property NameValuePair^ SelectedNameValue
			{
				NameValuePair^ get();
				void set(NameValuePair^ value);
			}


			MainViewModel(void);

			void Initialize();
			void Execute(Object^ parameter);
			bool CanExecute(Object^ parameter);

		private:
			bool _checkBox1;
			bool _checkBox2;
			String^ _statusResults;

			String^ _selectedValue;
			NameValuePair^ _SelectedNameValue;
			IVector<NameValuePair^>^ _NameValueList;
		};
	}
}