#include "pch.h"
#include "MockDataDal.h"
#include "NameListDal.h"

using namespace WsaWrcCpp::DataLayer;
using namespace WsaLibCpp;

MockDataDal::MockDataDal() { }



IVector<NameValuePair^>^ MockDataDal::GetDefaultList()
{
	auto list = ref new Vector<NameValuePair^>();
	list->Append(ref new NameValuePair("Name1", "Value1"));
	list->Append(ref new NameValuePair("Name2", "Value2"));
	list->Append(ref new NameValuePair("Name3", "Value3"));
	list->Append(ref new NameValuePair("Name4", "Value4"));
	return list;
}

IVector<NameValuePair^>^ MockDataDal::GetCowboyList()
{
	// Retrieve list from data access layer (WsaLibCpp)
	auto dal = new NameListDal();
	auto dalList = dal->GetCowboyList();

	// Instantiate list and populate it from dalList
	auto list = ref new Vector<NameValuePair^>();
	for (auto item : dalList)
	{
		// basic_string (map<string,string>)
		auto first = item.first;
		auto second = item.second;

		// wstring
		wstring wfirst(first.begin(), first.end());
		wstring wSecond(second.begin(), second.end());

		// String^
		auto stringOne = ref new String(wfirst.c_str());
		auto stringTwo = ref new String(wSecond.c_str());

		// Append map values to list
		list->Append(ref new NameValuePair(stringOne, stringTwo));

	}
	return list;
}

IVector<NameValuePair^>^ MockDataDal::GetHidingList()
{
	auto list = ref new Vector<NameValuePair^>();
	list->Append(ref new NameValuePair("John Smith", "JS001"));
	list->Append(ref new NameValuePair("Jane Doe", "JD001"));
	return list;
}

