﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"
#include "DataBindingPresenter.h"
#include "ReusedPresenter.h"

#include <string>

using namespace std;
using namespace Contoso;
//-----------------------

using namespace WsaXamlCpp;
using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

MainPage::MainPage()
{
	InitializeComponent();
}

/// <summary>
/// Handles button click.
/// </summary>
/// <param name="sender">The sender.</param>
/// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
void MainPage::AddClickHandler(Platform::Object^ sender, RoutedEventArgs^ e)
{
	auto calculator = ref new Calculator();

	// Convert strings to integers
	auto numberOne = stoi(txtNumberOne->Text->Data());
	auto numberTwo = stoi(txtNumberTwo->Text->Data());

	// Calculate values
	auto value = calculator->Add(numberOne, numberTwo);

	auto valueStrInt = calculator->AddStr(txtNumberOne->Text, txtNumberTwo->Text);

	if (value != valueStrInt)
		//http://www.global-webnet.com/blog/post/2013/03/10/Cpp-CX-how-to-throwcatch-user-defined-messages-(HResult).aspx
		throw ref new Exception(2684354560, "C++ DLL did not properly calculate value!");

	// Convert resulting value to wstring
	auto result = to_wstring(value);

	// Convert wstring to String^ and update UI
	txtResult->Text = ref new String(result.c_str());
}


void MainPage::DataBindingClickHandler(Object^ sender, RoutedEventArgs^ e)
{
	auto presenter = ref new DataBindingPresenter();
	presenter->Navigate(this->Frame);
}

void WsaXamlCpp::MainPage::ReusedClickHander(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	auto presenter = ref new ReusedPresenter();
	presenter->Navigate(this->Frame);
}


void WsaXamlCpp::MainPage::Button_Click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{

}
