﻿Imports System.IO
Imports System.Linq
Imports System.Runtime.InteropServices.WindowsRuntime
Imports Windows.Foundation
Imports Windows.Foundation.Collections
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Controls.Primitives
Imports Windows.UI.Xaml.Data
Imports Windows.UI.Xaml.Input
Imports Windows.UI.Xaml.Media
Imports Windows.UI.Xaml.Navigation
Imports WsaXamlCs.Presenters
Imports System

Namespace WsaXamlCs
    ''' <summary>
    ''' An empty page that can be used on its own or navigated to within a Frame.
    ''' </summary>
    Partial Public NotInheritable Class MainPage
        Inherits Page
        Public Sub New()
            Me.InitializeComponent()
        End Sub

        Private Sub AddClickHandler(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim calculator = New Contoso.Calculator()

            ' Convert strings to integers
            Dim numberOne = Integer.Parse(txtNumberOne.Text)
            Dim numberTwo = Integer.Parse(txtNumberTwo.Text)

            ' Calculate values (calculated in WRL component)
            Dim value = calculator.Add(numberOne, numberTwo)

            ' Calculate values (calculated in DLL component)
            Dim valueStrInt = calculator.AddStr(txtNumberOne.Text, txtNumberTwo.Text)

            If value IsNot valueStrInt Then
                Throw New Exception("C++ DLL did not properly calculate value!")
            End If

            ' Convert resulting value to string and update UI
            txtResult.Text = value.ToString()
        End Sub

        Private Sub DataBindingClickHandler(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim presenter = New DataBindingPresenter()
            presenter.Navigate(Frame)
        End Sub

        Private Sub ReusedClickHander(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim presenter = New ReusedPresenter()
            presenter.Navigate(Frame)
        End Sub
    End Class
End Namespace
