﻿Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports Windows.UI.Xaml.Controls
Imports WsaWrcCpp.DataLayer
Imports WsaWrcCpp.Interfaces
Imports WsaWrcCpp.ViewModel
Imports WsaWrcCs.Interfaces
Imports WsaWrcCs.Logger
Imports WsaXamlCs.Views

Namespace WsaXamlCs.Presenters
	Public Class DataBindingPresenter
		Implements IPresenter
		Private _logger As ILogger
		Private _view As DataBindingView
		Private _viewModel As MainViewModel

        Public Sub Initialize(ByVal view As Object) Implements IPresenter.Initialize
            _view = TryCast(view, DataBindingView)

            _logger.Log("Instantiate view model")
            _viewModel = New MainViewModel()

            _logger.Log("Attach to the view model to the view")
            _view.DataContext = _viewModel

            _logger.Log("Initializing view model")
            _viewModel.Initialize()

            _logger.Log("Setting list values on view model")

            ' In the real world a business logic layer would be called to 
            ' retrieve data. The BLL would access the DAL and return list
            Dim dal As MockDataDal = New MockDataDal()
            Dim item As WsaWrcCpp.ViewModel.NameValuePair
            For Each item In dal.GetCowboyList()
                _viewModel.NameValueList.Add(item)
            Next item

            ' Default to last record
            _viewModel.SelectedNameValue = _viewModel.NameValueList.First()
        End Sub

		Public Sub Navigate(ByVal frame As Frame)
			_logger.Log("Navigating to view", "NAVIGATION", "5")
			frame.Navigate(GetType(DataBindingView), Me)
		End Sub

        Public Sub CommandHandler(ByVal parameter As Object) Implements IPresenter.CommandHandler
            _logger.Log("CommandHandler executed", "COMMAND", "1")
            ' We'll keep default behavior
        End Sub

		Public Sub New()
			_logger = New DebugLogger()
		End Sub
	End Class
End Namespace
