﻿Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports Windows.UI.Xaml.Controls
Imports WsaWrcCpp.DataLayer
Imports WsaWrcCpp.Interfaces
Imports WsaWrcCpp.ViewModel
Imports WsaXamlCs.Views

Namespace WsaXamlCs.Presenters
	Public Class ReusedPresenter
		Implements IPresenter
		Private _counter As Integer
		Private _view As DataBindingView
		Private _viewModel As MainViewModel

        Public Sub Initialize(ByVal view As Object) Implements IPresenter.Initialize
            _view = TryCast(view, DataBindingView)

            ' Instantiate view model
            _viewModel = New MainViewModel()

            ' Attach to the View
            _view.DataContext = _viewModel

            ' Find the title on the view so we can replace the text
            Dim title As TextBlock = TryCast(_view.FindName("pageTitle"), TextBlock)
            title.Text = "Reused View and ViewModel"

            ' Initialize view model
            _viewModel.Initialize()

            ' Give reference to presenter because we are overriding command handler
            _viewModel.Presenter = CType(Me, IPresenter)

            _viewModel.NameValueList.Clear()

            ' In the real world a business logic layer would be called to retrieve data.
            ' The BLL would access the DAL and return list
            Dim dal As MockDataDal = New MockDataDal()
            Dim item As WsaWrcCpp.ViewModel.NameValuePair
            For Each item In dal.GetHidingList()
                _viewModel.NameValueList.Insert(0, item)
            Next item

            ' Default to Clint Eastwood
            _viewModel.SelectedNameValue = _viewModel.NameValueList.Last()
        End Sub

		Friend Sub Navigate(ByVal Frame As Frame)
			Frame.Navigate(GetType(DataBindingView), Me)
		End Sub

        Public Sub CommandHandler(ByVal parameter As Object) Implements IPresenter.CommandHandler
            Dim button As Button = TryCast(parameter, Button)

            ' Do something different - we could totally rewrite StatusResult but
            ' we'll simply append for demonstration purposes
            _counter += 1
            _viewModel.StatusResults += "\r\n\r\nOverride Status Results" & _counter & "\r\nButton clicked =>" & button.Name
        End Sub

	End Class
End Namespace
