﻿Imports WsaXamlCs.Common
Imports System.IO
Imports System.Linq
Imports System.Runtime.InteropServices.WindowsRuntime
Imports Windows.Foundation
Imports Windows.Foundation.Collections
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Controls.Primitives
Imports Windows.UI.Xaml.Data
Imports Windows.UI.Xaml.Input
Imports Windows.UI.Xaml.Media
Imports Windows.UI.Xaml.Navigation
Imports WsaWrcCpp.Interfaces

' The Basic Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234237

Namespace WsaXamlCs.Views
	''' <summary>
	''' A basic page that provides characteristics common to most applications.
	''' </summary>
	Public NotInheritable Partial Class DataBindingView
		Inherits Page

'INSTANT VB NOTE: The variable navigationHelper was renamed since Visual Basic does not allow class members with the same name:
		Private navigationHelper_Renamed As NavigationHelper
'INSTANT VB NOTE: The variable defaultViewModel was renamed since Visual Basic does not allow class members with the same name:
		Private defaultViewModel_Renamed As New ObservableDictionary()

		''' <summary>
		''' This can be changed to a strongly typed view model.
		''' </summary>
		Public ReadOnly Property DefaultViewModel() As ObservableDictionary
			Get
				Return Me.defaultViewModel_Renamed
			End Get
		End Property

		''' <summary>
		''' NavigationHelper is used on each page to aid in navigation and 
		''' process lifetime management
		''' </summary>
		Public ReadOnly Property NavigationHelper() As NavigationHelper
			Get
				Return Me.navigationHelper_Renamed
			End Get
		End Property


		Public Sub New()
			Me.InitializeComponent()
			Me.navigationHelper_Renamed = New NavigationHelper(Me)
			AddHandler Me.navigationHelper_Renamed.LoadState, AddressOf navigationHelper_LoadState
			AddHandler Me.navigationHelper_Renamed.SaveState, AddressOf navigationHelper_SaveState
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
			navigationHelper_Renamed.OnNavigatedTo(e)
			Dim presenter = TryCast(e.Parameter, IPresenter)
			If presenter IsNot Nothing Then
				presenter.Initialize(Me)
			End If
		End Sub

		Protected Overrides Sub OnNavigatedFrom(ByVal e As NavigationEventArgs)
			navigationHelper_Renamed.OnNavigatedFrom(e)
		End Sub


		''' <summary>
		''' Populates the page with content passed during navigation. Any saved state is also
		''' provided when recreating a page from a prior session.
		''' </summary>
		''' <param name="sender">
		''' The source of the event; typically <see cref="NavigationHelper"/>
		''' </param>
		''' <param name="e">Event data that provides both the navigation parameter passed to
		''' <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested and
		''' a dictionary of state preserved by this page during an earlier
		''' session. The state will be null the first time a page is visited.</param>
		Private Sub navigationHelper_LoadState(ByVal sender As Object, ByVal e As LoadStateEventArgs)
		End Sub

		''' <summary>
		''' Preserves state associated with this page in case the application is suspended or the
		''' page is discarded from the navigation cache.  Values must conform to the serialization
		''' requirements of <see cref="SuspensionManager.SessionState"/>.
		''' </summary>
		''' <param name="sender">The source of the event; typically <see cref="NavigationHelper"/></param>
		''' <param name="e">Event data that provides an empty dictionary to be populated with
		''' serializable state.</param>
		Private Sub navigationHelper_SaveState(ByVal sender As Object, ByVal e As SaveStateEventArgs)
		End Sub

		''' The methods provided in this section are simply used to allow
		''' NavigationHelper to respond to the page's navigation methods.
		''' 
		''' Page specific logic should be placed in event handlers for the  
		''' <see cref="GridCS.Common.NavigationHelper.LoadState"/>
		''' and <see cref="GridCS.Common.NavigationHelper.SaveState"/>.
		''' The navigation parameter is available in the LoadState method 
		''' in addition to page state preserved during an earlier session.



	End Class
End Namespace
